package com.hai.order.model.combine;

import com.alibaba.fastjson.JSONObject;
import com.hai.order.model.CreateOrderModel;
import lombok.Data;

import java.util.List;

/**
 * @author sum1dream
 */
@Data
public class CombineOrderModel {

    /**
     * @Author Sum1Dream
     * @Description // 合单商户appid
     * @Date 2023/8/7 15:21
     */
    private String combineAppid;

    /**
     * @Author Sum1Dream
     * @Description // 合单商户号
     * @Date 2023/8/7 15:21
     */
    private String combineMchId;

    /**
     * @Author Sum1Dream
     * @Description // 合单商户订单号
     * @Date 2023/8/7 15:21
     */
    private String combineOutTradeNo;

    /**
     * @Author Sum1Dream
     * @Description // 子单信息
     * @Date 2023/8/7 15:21
     */
    private List<SubOrders> subOrders;

    /**
     * @Author Sum1Dream
     * @Description // 支付者信息
     * @Date 2023/8/7 15:21
     */
    private JSONObject combinePayerInfo;

    /**
     * @Author Sum1Dream
     * @Description // 接收微信支付异步通知回调地址
     * @Date 2023/8/7 15:21
     */
    private String notifyUrl;

}
