package com.hai.model;

import com.hai.entity.HighCoupon;
import com.hai.entity.HighCouponHandsel;
import lombok.Data;

import java.util.List;

/**
 * @Auther: 胡锐
 * @Description: 卡卷模型
 * @Date: 2021/3/11 22:27
 */
@Data
public class HighCouponModel {

    // 商户名称
    private String merchantName;

    // 库存数量
    private Integer stockCount;

    private Integer monthlySales;

    // 赠送卡卷id
    private List<Long> handselCouponId;

    // 购买数量上限
    private Boolean numberUpperLimitStatus;

    // 赠送卡卷
    private List<HighCouponHandselModel> handselCouponList;
}
