package com.hai.openApi.service;

import com.hai.entity.ApiBlxCoupon;

import java.util.List;
import java.util.Map;

public interface ApiBlxCouponService {

    /**
     * @Author Sum1Dream
     * @Name insertBlxCoupon
     * @Description // 新增停车券
     * @Date 14:20 2023/7/11
     * @Param [apiBlxCoupon]
     * @Return void
     */
    void insertBlxCoupon(ApiBlxCoupon apiBlxCoupon);

    /**
     * @Author Sum1Dream
     * @Name editBlxCoupon
     * @Description // 修改停车券
     * @Date 14:23 2023/7/11
     * @Param [apiBlxCoupon]
     * @Return void
     */
    void editBlxCoupon(ApiBlxCoupon apiBlxCoupon);

    /**
     * @Author Sum1Dream
     * @Name FindBlxCoupon
     * @Description // 根据卡券编码查询券
     * @Date 14:23 2023/7/11
     * @Param [couponCode]
     * @Return com.hai.entity.ApiBlxCoupon
     */
    ApiBlxCoupon findBlxCoupon(String couponCode);

    /**
     * @Author Sum1Dream
     * @Name getBlxCouponList
     * @Description // 查询停车券列表
     * @Date 14:23 2023/7/11
     * @Param [map]
     * @Return java.util.List<com.hai.entity.ApiBlxCoupon>
     */
    List<ApiBlxCoupon> getBlxCouponList(Map<String , Object> map);

}
